------------------------------------------------------------------------
-- Event:        Community Days 2014, Roma 23-25 Settembre 2014
-- Session:      Keynote
-- Demo:         Hekaton
-- Author:       Sergio Govoni
-- Notes:        --
------------------------------------------------------------------------

USE [CommunityDays];
GO

SELECT * FROM dbo.ElapsedTime;

/*
-- Ogni SP inserisce 10.000 righe con 10 thread

-- Disk-based table
ostress -SBAINBRIDGE -E -dCommunityDays -Q"EXEC dbo.usp_Insert_SalesOrderHeaderDisk" -n10 -q -oC:\SQL\Temp\RML

-- In-Memory table, schema and data
ostress -SBAINBRIDGE -E -dCommunityDays -Q"EXEC dbo.usp_Insert_SalesOrderHeaderHSD" -n10 -q -oC:\SQL\Temp\RML

-- In-Memory table, schema only
ostress -SBAINBRIDGE -E -dCommunityDays -Q"EXEC dbo.usp_Insert_SalesOrderHeaderHSO" -n10 -q -oC:\SQL\Temp\RML

-- In-Memory table, schema and data, compiled stored procedure
ostress -SBAINBRIDGE -E -dCommunityDays -Q"EXEC dbo.usp_Insert_SalesOrderHeaderH_C_SD" -n10 -q -oC:\SQL\Temp\RML

-- In-Memory table, schema only, compiled stored procedure
ostress -SBAINBRIDGE -E -dCommunityDays -Q"EXEC dbo.usp_Insert_SalesOrderHeaderH_C_SO" -n10 -q -oC:\SQL\Temp\RML

*/

SELECT
  --*
  --,DATEDIFF(MILLISECOND, MIN(StartTime), MAX(EndTime))
 StartTime
 ,EndTime
 ,(DATEPART(MILLISECOND, (EndTime - StartTime)))
 ,DATEPART(SECOND, (EndTime - StartTime))
FROM
  dbo.ElapsedTime
WHERE
  (SPName = 'usp_Insert_SalesOrderHeaderH_C_SD');
GO


WITH CTE AS
(
SELECT
  SPName
  --,CAST(DATEDIFF(MILLISECOND, MIN(StartTime), MAX(EndTime))/1000.0 AS DECIMAL(7, 3))
  --,(DATEPART(SECOND, (EndTime - StartTime)) + (DATEPART(MILLISECOND, (EndTime - StartTime)) / 1000.0))
  ,StartTime = MIN(StartTime) OVER (PARTITION BY SPName)
  ,EndTime = MAX(EndTime) OVER (PARTITION BY SPName)
  ,RowN = ROW_NUMBER() OVER (PARTITION BY SPName ORDER BY StartTime)
FROM
  dbo.ElapsedTime
--WHERE
--  (SPName = 'usp_Insert_SalesOrderHeaderH_C_SD')
),
CTE1 AS
(
SELECT
  SPName
  --,StartTime
  --,EndTime
  ,ElapsedTime = CAST(DATEPART(SECOND, (EndTime - StartTime)) AS DECIMAL(7, 3)) + CAST((DATEPART(MILLISECOND, (EndTime - StartTime)) / 1000.0) AS DECIMAL(7, 3))
FROM
  CTE
WHERE
  (RowN = 1)
)
SELECT
  *
  ,(100000.0 / ElapsedTime) [Requests/Sec]
FROM
  CTE1
ORDER BY
  SPName DESC
GO


SELECT COUNT(*) FROM dbo.SalesOrderHeaderDisk;
SELECT COUNT(*) FROM dbo.SalesOrderHeaderHSD;
SELECT COUNT(*) FROM dbo.SalesOrderHeaderHSO;
SELECT COUNT(*) FROM dbo.SalesOrderHeaderH_C_SD;
SELECT COUNT(*) FROM dbo.SalesOrderHeaderH_C_SO;
GO